function Epg(){
	this.searchtimer;
	
	this.isSelected = false;
	this.contentHeight = 0;
	this.height = 0;	

	this.searchContentHeight = 0;
	this.searchHeight = parseInt(loadPref("epgSearchScrollPoint"), 10);	

	this.resizeorigin = 0;
	resizestart = 0;
	
	this.channelContainers = new Object();
	this.contentArray = new Array();
	
	this.setupComplete = false;
	
	this.visibleShows = parseInt(loadPref("nowAndNext"), 10);
	this.timeFormat = parseInt(loadPref("twentyFourHourClock"), 10);
	this.filterDay = parseInt(loadPref("currentFilterDay"), 10)
	this.filterTime = parseInt(loadPref("currentFilterTime"), 10)
	
	this.inSearch = false;
	this.searchString = null;
	this.usingRestoredSearch = false;
	this.recentSearches = Array();
	this.recentSearchesMenu = Array();
	
	this.searchResultDayHeaders = new Array();
	
	this.dlHeader = {};
	
	this.mode = "1";
	
	this.lastDateString = null;
}

Epg.prototype.setup = function(){
	var _self = this;
		
	this.updateFilterTime();
	
	document.getElementById("epgsearch_resize_control").onmousedown = function(event){ _self.beginresize();};
	document.getElementById("epgsearch_resize_control").ondblclick = function(event){ _self.resetHeight(); }
	document.getElementById("epg-controls-search").onsearch = function(){ _self.searchPrelim()};
}

Epg.prototype.clear = function(){
	while(document.getElementById("epgsearch_content_inner_container").hasChildNodes())
		document.getElementById("epgsearch_content_inner_container").removeChild(document.getElementById("epgsearch_content_inner_container").firstChild);
	this.inSearch = false;
	this.searchString = null;
	document.getElementById("epg_guide_content").style.display = "block";
	document.getElementById("epgsearch_container").style.display = "none";
	this.searchContentHeight = 0;
	
	this.channelContainers = new Object();
	this.contentArray.length = 0;
	this.contentHeight = 0;
	while(document.getElementById("epg_guide_content").hasChildNodes())
		document.getElementById("epg_guide_content").removeChild(document.getElementById("epg_guide_content").firstChild);

	this.isSelected = false;
}


Epg.prototype.downloaderCallback = function(json){
	this.parseData(json);
	this.updateDisplay();
	
//    DEBUGLOG("epg.js[72]: this.inSearch: " + this.inSearch + "    this.searchString: " + this.searchString);
	if(this.inSearch && this.searchString != null){
		epg.doSearch();
		return;
	}
	
	this.resize();
}

Epg.prototype.updateData = function(userInitiated){
//	DEBUGLOG("epg.js[82]: Epg.updateData(" + userInitiated + ")");
	var currentDate = new Date();
	var currentEpoch = parseInt(currentDate.getTime() / 1000, 10);
	var lastFetch = this.dlHeader['last_fetch'] ? this.dlHeader['last_fetch'] : 0;
	var timeDifference = currentEpoch - lastFetch;
	var minTimeDifference = (this.dlHeader['min_hit_minutes'] ? this.dlHeader['min_hit_minutes'] : 60) * 60;
	
	if(userInitiated == 'false' && (timeDifference < minTimeDifference)){
		DEBUGLOG("epg.js[90]: Auto fetch and last fetch within minimum hit time.");
		return;
	}
	if(epgDownloader.active)
		return;
	
	var lastUpdate = (this.dlHeader['last_update']) ? this.dlHeader['last_update'] : 0;
	var currentDateString = currentDate.getFullYear() + "/" + currentDate.getMonth() + "/" + currentDate.getDate();
	
	if(currentDateString != this.lastDateString){ // Trying to workaround a bug where the widget ends up with no data by forcing it to reload everything once each day
		this.lastDateString = currentDateString;
		epgDownloader.buildURL(0, true);
	} else
		epgDownloader.buildURL(lastUpdate, userInitiated);
	
	rmtQueue.setSubActive(kEpgFeed);
	epgDownloader.fetchURL();
}	

Epg.prototype.parseData = function(json){
    var currentDate = new Date();
	var currentDateString = currentDate.getFullYear() + "/" + currentDate.getMonth() + "/" + currentDate.getDate();
	this.lastDateString = currentDateString;
	this.dlHeader['last_fetch'] = parseInt(currentDate.getTime() / 1000);
	
	var tempArray = eval(json);
	if(!tempArray)
		return;
        
    DEBUGLOG("epg.js[117]: return_code: " + tempArray[0]['return_code']);

	if(tempArray[0]['return_code'] != 0){
		DEBUGLOG("epg.js[120]: Epg Fetch Failed, return code: " + tempArray[0]['return_code']);
		this.dlHeader["return_code"] = tempArray[0]['return_code'];
		if(this.dlHeader['return_code'] == "10") {
			ath.expire();
            return;
        } else if(this.dlHeader['return_code'] == "55") {
			ath.subExpired();
            return;
        }
		return;
	}
	
	if(tempArray[0]['number_of_programs'] == "0"){
//		DEBUGLOG("epg.js[129]: No EPG update.");
		this.mode = tempArray[0]['num_days_epg'];
		this.dlHeader['last_update'] = tempArray[0]['last_update'];
		this.dlHeader['min_hit_minutes'] = tempArray[0]['min_hit_minutes'];
		this.dlHeader['last_fetch'] = parseInt(currentDate.getTime() / 1000);
		return;
	}
	
	if(this.contentArray.length == 0) {
		this.dlHeader = tempArray.shift();
		this.mode = this.dlHeader['num_days_epg'];
		this.contentArray = this.contentArray.concat(tempArray);
	} else {
		this.dlHeader['last_update'] = tempArray[0]['last_update'];
		this.dlHeader['min_hit_minutes'] = tempArray[0]['min_hit_minutes'];
		this.mode = tempArray[0]['num_days_epg'];

		tempArray.shift();
		this.mergeEpg(tempArray);
		this.dlHeader['number_of_programs'] = parseInt(this.contentArray.length);
	}
	this.dlHeader['last_fetch'] = parseInt(currentDate.getTime() / 1000);
}

Epg.prototype.updateDisplay = function(){
    DEBUGLOG("epg.js[160]: Epg.updateDisplay()");
	if(!this.setupComplete)
		return;

	var channelList = chm.contentArray;
	var sortedData = this.getEpgList();
	
    var upcomingList = mgu.contentArray;
    var seriesList = mgs.contentArray;
    var keywordsList = key.contentArray;
    
	var currentContainer = null;
	var offset = 0;
	var frameOffset = 0;
	for(x=0;x<channelList.length;x++){
		if(!this.channelContainers[channelList[x]["id"]])
			continue;
	
        for(y=0;y<5;y++) {
            var showItem = this.channelContainers[channelList[x]["id"]].showItems[y];
            while(showItem.remoteIcons.firstChild != null)
                showItem.remoteIcons.removeChild(showItem.remoteIcons.firstChild);
            showItem.stitle.innerHTML = "";
            showItem.episode.innerHTML = "";
            showItem.time.innerHTML = "";
            showItem.stitle.onclick = null;
        }
    
		var channelShows = sortedData[channelList[x]["id"]];
        if(!channelShows)
            continue;
        
		for(y=0;y<5;y++){
			var rmtContainer = this.channelContainers[channelList[x]["id"]].showItems[y].remoteIcons;
			if(channelShows && channelShows.length > y){
				channelShows[y]['is_favorite']		= isFavoriteYWE(channelShows[y]['series_id']);
				channelShows[y]['part_of_series']	= isPartOfSeriesYWE(channelShows[y]['series_id']);
				channelShows[y]['is_scheduled']		= isScheduledYWE(channelShows[y]['id']);
				channelShows[y]['is_recommended']	= isRecommendedYWE(channelShows[y]['series_id']);
				channelShows[y]['is_keyword']       = isKeywordYWE(channelShows[y]['id']);
                channelShows[y]['view_or_record']   = keywordViewOrRecordYWE(channelShows[y]['id']);
        
				var iconSize = 0;
				while (rmtContainer.hasChildNodes())
					rmtContainer.removeChild(rmtContainer.firstChild);
	
				if(channelShows[y]['is_scheduled'] == "1"){
					if(channelShows[y]['part_of_series'] == "1"){
						var statusImage = document.createElement("img");
						statusImage.src = "images/remoteicons/remote_recseries.png";
						statusImage.width = 14;
						statusImage.height = 12;
						statusImage.style.position = "absolute";
						rmtContainer.appendChild(statusImage);
						statusImage.style.left = "0px";
						iconSize += 18
					} else {
						var statusImage = document.createElement("img");
						statusImage.src = "images/remoteicons/remote_rec.png";
						statusImage.width = 8;
						statusImage.height = 12;
						rmtContainer.appendChild(statusImage);
						statusImage.hOffset = iconSize;
						iconSize += 12;
					}
                    
                    if(channelShows[y]['is_keyword'] == "1" && channelShows[y]['view_or_record'] == "1") {
                        var statusImage = document.createElement("img");
                        statusImage.src = "images/remoteicons/remote_smartrec.png";
                        statusImage.width = 8;
                        statusImage.height = 12;
                        statusImage.style.position = "absolute";
                        statusImage.style.left = (iconSize) + "px";
                        iconSize += 12;
                        rmtContainer.appendChild(statusImage);
                    }
				} else {
                    if(channelShows[y]['part_of_series'] == "1"){
						var statusImage = document.createElement("img");
						statusImage.src = "images/remoteicons/remote_recseries_cancel.png";
						statusImage.width = 14;
						statusImage.height = 12;
						statusImage.style.position = "absolute";
						rmtContainer.appendChild(statusImage);
						statusImage.style.left = "0px";
						iconSize += 18
                    }
                }
		
				if(channelShows[y]['is_favorite'] == "1") {
                    var statusImage = document.createElement("img");
                    statusImage.src = "images/remoteicons/remote_favourite.png";
                    statusImage.width = 14;
                    statusImage.height = 12;
                    statusImage.style.position = "absolute";
                    statusImage.style.left = (iconSize) + "px";
                    iconSize += 18
                    rmtContainer.appendChild(statusImage);
				}

                if(channelShows[y]['is_keyword'] == "1" && channelShows[y]['view_or_record'] == "0") {
                    var statusImage = document.createElement("img");
                    statusImage.src = "images/remoteicons/remote_smartfavourite.png";
                    statusImage.width = 8;
                    statusImage.height = 12;
                    statusImage.style.position = "absolute";
                    statusImage.style.left = (iconSize) + "px";
                    iconSize += 12
                    rmtContainer.appendChild(statusImage);
                }

				if(channelShows[y]['is_recommended'] == "1" && channelShows[y]['is_favorite'] == "0" && channelShows[y]['is_scheduled'] == "0") {
                    var statusImage = document.createElement("img");
                    statusImage.src = "images/remoteicons/remote_recommended.png";
                    statusImage.width = 8;
                    statusImage.height = 12;
                    statusImage.style.position = "absolute";
                    statusImage.style.left = (iconSize) + "px";
                    iconSize += 12
                    rmtContainer.appendChild(statusImage);
				}

				if(iconSize > 0)
					iconSize += 1;	

				var showName = this.channelContainers[channelList[x]["id"]].showItems[y].stitle;
				var nameContainer = this.channelContainers[channelList[x]["id"]].showItems[y].nameContainer;
				var episode = this.channelContainers[channelList[x]["id"]].showItems[y].episode;

				var time;
				var showDate = new Date();

                var year	= parseInt(channelShows[y]['time'].substring(0,4),   10); 
                var month	= parseInt(channelShows[y]['time'].substring(5,7),   10);
                var day     = parseInt(channelShows[y]['time'].substring(8,10),  10);
                var hour	= parseInt(channelShows[y]['time'].substring(11,13), 10); 
                var minute	= parseInt(channelShows[y]['time'].substring(14,16), 10);
                var second	= parseInt(channelShows[y]['time'].substring(17,19), 10);
                
                showDate = new Date(year, month-1, day, hour, minute, second);

				if(epg.timeFormat == 24){
					var minutes = showDate.getMinutes();
					if(minutes < 10)
						minutes = "0" + minutes;
						
					var hours = showDate.getHours();
					if(hours < 10)
						hours = "0" + hours;
		
					time = hours + ':' + minutes;
				} else {
					if(showDate.getHours() >= 12)
						suffix = "pm"
					else
						suffix = "am"
					
					var hours = showDate.getHours();
					if(hours == 0)
						hours = 12;
					else if(hours > 12)
						hours -= 12;
		
					var minutes = showDate.getMinutes();
					if(minutes < 10)
						minutes = "0" + minutes;
					time = hours + ':' + minutes + suffix;
				}
				this.channelContainers[channelList[x]["id"]].showItems[y].time.innerHTML = time;

				showName.innerHTML = channelShows[y]['title'];
				if(channelShows[y]['year'] && channelShows[y]['year'].length == 4)
					showName.innerHTML += " (" + channelShows[y]['year'] + ")";

                /**
                 * Check if the program is on NOW and if so colour the text orange like on the website.
                 */
                var dateNow = new Date();
                var showEndDate = new Date();

                var year	= parseInt(channelShows[y]['time'].substring(0,4),   10); 
                var month	= parseInt(channelShows[y]['time'].substring(5,7),   10);
                var day     = parseInt(channelShows[y]['time'].substring(8,10),  10);
                var hour	= parseInt(channelShows[y]['time'].substring(11,13), 10); 
                var minute	= parseInt(channelShows[y]['time'].substring(14,16), 10);
                var second	= parseInt(channelShows[y]['time'].substring(17,19), 10);
                
                var showDate = new Date(year, month-1, day, hour, minute, second);
        
                var showDateString = showDate.getFullYear() + "/" + showDate.getMonth() + "/" + showDate.getDate();;

                showEndDate = new Date();
                showEndDate.setTime(showDate.getTime());
                showEndDate.setTime(showEndDate.getTime() + (parseInt(channelShows[y]['duration'], 10) * 60 * 1000));
        
                if((showDate.getTime() <= dateNow.getTime()) && (showEndDate.getTime() >= dateNow.getTime()))
                    showName.style.color = "#DB8921"; // On NOW colour
                else
                    showName.style.color = "#B6BBC3";

									
				if(channelShows[y]['subtitle'])
					episode.innerHTML = " '" + channelShows[y]['subtitle'] + "'";
				else
					episode.innerHTML = "";

				nameContainer.style.width = (260 - iconSize - 5) + "px";
				nameContainer.style.left = (107 + iconSize) + "px";
				nameContainer.setAttribute("onclick", "sht.fillEpgSheetDetails('" + channelShows[y]["id"] +"', 1, false, false)");
				rmtContainer.setAttribute("onclick", "sht.fillEpgSheetDetails('" + channelShows[y]["id"] +"', 1, false, false)");
				this.channelContainers[channelList[x]["id"]].showItems[y].time.setAttribute("onclick", "sht.fillEpgSheetDetails('" + channelShows[y]["id"] +"', 1, false, false)");
			} else {
				while(rmtContainer.firstChild != null)
					rmtContainer.removeChild(rmtContainer.firstChild);
				this.channelContainers[channelList[x]["id"]].showItems[y].stitle.innerHTML = "";
				this.channelContainers[channelList[x]["id"]].showItems[y].episode.innerHTML = "";
				this.channelContainers[channelList[x]["id"]].showItems[y].time.innerHTML = "";
				this.channelContainers[channelList[x]["id"]].showItems[y].stitle.onclick = null;
				
			}
		}
	}
}

Epg.prototype.buildDisplay = function(){
//    DEBUGLOG("epg.js[341]: buildDisplay");
	this.setupComplete = true;
	var channelList = chm.sortedList;
	
    /**
     * Empty the EPG content container
     */
	for(x=0;x<channelList.length;x++){
		var container = document.createElement("div");
		container.style.position = "absolute";
		if(this.visibleShows == 5){
			container.style.background = "url(images/lists/list_epg_5.png)"
			container.style.top = (x * 77) + "px";
			container.style.height = 77 + "px";
		} else {
			container.style.background = "url(images/lists/list_epg_3.png)"
			container.style.top = (x * 51) + "px";
			container.style.height = 51 + "px";
		}
		container.style.width = 380 + "px";
		document.getElementById("epg_guide_content").appendChild(container);

		var channel = document.createElement("img");
		channel.src = chm.iconForChannel(channelList[x]);
		channel.height = 39;
		channel.width = 44;
		channel.style.position = "absolute"
		channel.style.left = "10px";
		if(this.visibleShows == 5)
			channel.style.top = "20px";
		else
			channel.style.top = "7px";
		container.appendChild(channel);
		
		var showContainers = Array();
		for(y=0;y<5;y++){
			var time = document.createElement("div");
			time.style.font = "bold 10px Lucida Grande";
			time.style.position = "absolute";
			time.style.color = "#B6BBC3";
			time.style.width = "45px";
			time.style.textAlign = "right";
			time.style.top = (6 + (y * 13) ) + "px";
			time.style.left = "55px";
			if(!(y < this.visibleShows))
				time.style.display = "none";
			
			container.appendChild(time);
			
			var nameContainer = document.createElement("div");
			nameContainer.style.top = (6 + (y * 13)) + "px";
			nameContainer.style.left = "107px";
			nameContainer.style.font = "bold 10px Lucida Grande";
			nameContainer.style.position = "absolute";
			nameContainer.style.color = "#ffffff";
			nameContainer.style.left = "107px";
			nameContainer.setAttribute("class", "ellipsis");
			container.appendChild(nameContainer);
			if(!(y < this.visibleShows))
				nameContainer.style.display = "none";

			var showname = document.createElement("span");
			nameContainer.appendChild(showname);

			var episode = document.createElement("span");
			episode.style.color = "#6ED8F8";
			nameContainer.appendChild(episode);
			
			var rmt = document.createElement("div");
			rmt.style.top = (8 + (y * 13)) + "px";
			rmt.style.left = "107px";
			rmt.style.height = "12px";
			rmt.style.position = "absolute";
			container.appendChild(rmt);
			if(!(y < this.visibleShows))
				rmt.style.display = "none";

			var showDetails = {time:time, nameContainer:nameContainer, stitle:showname, episode:episode, remoteIcons:rmt}
			showContainers.push(showDetails)
		}
		
		this.channelContainers[channelList[x]] = {id:channelList[x], container:container, showItems:showContainers, logo:channel};
	}
	this.updateChannelVisibilty();
}

Epg.prototype.updateChannelVisibilty = function(){
	var sortOrder = chm.sortedList;
	var added = 0;
	for(x=0;x<sortOrder.length;x++){
		if(chm.isHidden(sortOrder[x])){
			this.channelContainers[sortOrder[x]].container.style.display = "none";
			continue;
		}
		
		this.channelContainers[sortOrder[x]].container.style.display = "block";
		if(this.visibleShows == 5)
			this.channelContainers[sortOrder[x]].container.style.top = (77 * added) + "px";
		else
			this.channelContainers[sortOrder[x]].container.style.top = (51 * added) + "px";
		added++;
	}
	if(this.visibleShows == 5)
		this.contentHeight = added * 77;
	else
		this.contentHeight = added * 51;
	this.resize();			
}

Epg.prototype.hide = function(){
	document.getElementById("epg_container").style.display = "none";
}

Epg.prototype.show = function(){
	document.getElementById("epg_container").style.display = "block";
}

Epg.prototype.sectionHeight = function(){
	height = this.contentHeight;
	if(height == 0)
		return 74;
	return height;
}

Epg.prototype.resize = function(){
	if(this.inSearch){
		var height = this.searchSectionHeight();
	
		document.getElementById("epgsearch_container").style.height = (height - 3) + "px";
		document.getElementById("epgsearch_content_inner_container").style.height = (this.searchContentHeight) + "px"
		document.getElementById("epgsearch_content_container").style.height = height + "px";
		document.getElementById("epgsearch_resize_control").style.top = (height - 16) + "px";
		document.getElementById("epgsearch_scrollbar").style.height = (height - 21) + "px";
		
		if(this.isSelected){
			document.getElementById("epg_container").style.height = height + "px";
			resizeFront(72 + (height - 2) + 35)
			document.getElementById("main_container").style.height = (height - 10) + "px";
			document.getElementById("main_base").style.top = (72 + height - 10) + "px";
		}
		epgScroller.refresh();
		epgScrollArea.refresh();
	} else {
		var height = this.sectionHeight();
	
		document.getElementById("epg_container").style.height = height + "px";
		document.getElementById("epg_guide_content").style.height = height + "px";
	
		if(this.isSelected){
			resizeFront(72 + (height) + 35)
			document.getElementById("main_container").style.height = (height - 12) + "px";
			document.getElementById("main_base").style.top = (72 + height - 12) + "px";
		}
	}
}

Epg.prototype.mergeEpg = function(tempArray){
	var tempArrayLength = tempArray.length;
	var getEpgArrayLength = this.contentArray.length;
	
	var idx;
	var idx2;
	var showIdFound = false;
	
	for(idx=0; idx<tempArrayLength; idx++)
	{
		var tempRec = tempArray[idx];
		if(!tempRec['id'])
			continue;
			
		for(idx2=0; idx2<getEpgArrayLength; idx2++)
		{
			var epgRec = this.contentArray[idx2];
			if(!epgRec['id'])
				continue;
			
			if(tempRec['id'] == epgRec['id']){
				DEBUGLOG("epg.js[492]: id: " + epgRec['id'] + " has been updated, replacing.");
				this.contentArray[idx2] = tempRec;
				showIdFound = true;
				break;
			}
		}

		if(!showIdFound && tempRec['id']){
			DEBUGLOG("epg.js[500]: id: " + tempRec['id'] + " is new, adding.");
			this.contentArray.push(tempRec);
		}
		else
			showIdFound = false;
	}
}

Epg.prototype.getEpgList = function(userInitiated){
	tvguideEpgList  = Array();
	
    /**
     * startDate: Current filter time, for paid members has 7 days added to it.
     */
	startDate = new Date();
	startDate.setSeconds(0);
	
	if(this.filterTime > -1)
		startDate.setHours(this.filterTime, 0);

    if(this.mode == "7")
		startDate.setTime(startDate.getTime() + (this.filterDay * 86400000));
	
    /**
     * Set End Date to 06:00 tomorrow.
     * We do this to show programs that run over into tomorrow.
     */
	endDate = new Date();
    endDate.setTime(startDate.getTime() + 86400000);
    endDate.setHours(6);

    /**
     * Number of 3 or 5 program 'channel slots' still to be filled.
     */
	var channelSlotsToFill = chm.sortedList.length;
	
    /**
     * Iterate through EPG looking for matching programs.
     */
	epgRecordCount = this.contentArray.length;
	for(var i=0; i<epgRecordCount; i++){
        /**
         * If all 'channel slots' are full then abort.
         */
		if(channelSlotsToFill < 0){
			break;
		}
			
        /**
         * If the EPG record has no 'time' details then discard it
         */
		if(!this.contentArray[i]['time']){
			continue;
		}

        /**
         * Calculate program start time
         */
        var year	= parseInt(this.contentArray[i]['time'].substring(0,4),   10); 
        var month	= parseInt(this.contentArray[i]['time'].substring(5,7),   10);
        var day     = parseInt(this.contentArray[i]['time'].substring(8,10),  10);
        var hour	= parseInt(this.contentArray[i]['time'].substring(11,13), 10); 
        var minute	= parseInt(this.contentArray[i]['time'].substring(14,16), 10);
        var second	= parseInt(this.contentArray[i]['time'].substring(17,19), 10);
		
        programStartDate = new Date(year, month-1, day, hour, minute, second);

        /**
         * Calculate program end time
         */
		programEndDate = new Date();
		programEndDate.setTime(programStartDate.getTime() + (parseInt(this.contentArray[i]['duration'], 10) * 60 * 1000));

        /**
         * If the program end before the start of the filter period then discard it
         */
        if(programEndDate.getTime() < startDate.getTime()) {
            continue;
        }
        

        /**
         * if program starts after the end of the filter period, since EPG is sorted chronologically, we can stop looking
         */
        if(programEndDate.getTime() > endDate.getTime()) {
            break;
        }

        /**
         * If this is the first program for a channel then add a new array for that channel.
         */
		if(!tvguideEpgList[this.contentArray[i]['channel_id']])
			tvguideEpgList[this.contentArray[i]['channel_id']] = new Array();

        /**
         * If the 'channel slot' for this channel is full then discard the new program
         */
		else if(tvguideEpgList[this.contentArray[i]['channel_id']].length >= this.visibleShows){
			continue;
		}

        /**
         * We have a new program so create a record to hold its details.
         */
		var tmpEpgRec = new Object();
		tmpEpgRec['id']              = this.contentArray[i]['id'];
		tmpEpgRec['series_id']       = this.contentArray[i]['series_id'];
		tmpEpgRec['title']           = this.contentArray[i]['title'];
		tmpEpgRec['subtitle']        = this.contentArray[i]['subtitle'];
		tmpEpgRec['category_name']   = this.contentArray[i]['category_name'];
		tmpEpgRec['actors']          = this.contentArray[i]['actors'];
		tmpEpgRec['year']            = this.contentArray[i]['year'];
		tmpEpgRec['director']        = this.contentArray[i]['director'];
		tmpEpgRec['duration']        = this.contentArray[i]['duration'];
		tmpEpgRec['start_timestamp'] = this.contentArray[i]['start_timestamp'];
		tmpEpgRec['channel_id']      = this.contentArray[i]['channel_id'];
		tmpEpgRec['time']            = this.contentArray[i]['time'];

        /**
         * Add channel to array
         */
		tvguideEpgList[this.contentArray[i]['channel_id']].push(tmpEpgRec);

        /**
         * If the current 'channel slot' is now full then decrease the count of open slots.
         */
		if(tvguideEpgList[this.contentArray[i]['channel_id']].length == this.visibleShows){
			channelSlotsToFill--;
		}
		
	}
	return tvguideEpgList;
}

Epg.prototype.recordForID = function(show_id){
	var getEpgArrayLength = this.contentArray.length;
	
	for(var i=0;i<getEpgArrayLength;i++){
		if(this.contentArray[i]['id'] == show_id){
			this.contentArray[i]['is_favorite']     = isFavoriteYWE(this.contentArray[i]['series_id']);
			this.contentArray[i]['part_of_series']  = isPartOfSeriesYWE(this.contentArray[i]['series_id']);
			this.contentArray[i]['is_scheduled']    = isScheduledYWE(this.contentArray[i]['id']);
			this.contentArray[y]['is_recommended']	= isRecommendedYWE(this.contentArray['series_id']);
			this.contentArray[y]['is_keyword']      = isKeywordYWE(this.contentArray['id']);
            this.contentArray[y]['view_or_record']  = keywordViewOrRecordYWE(this.contentArray['id']);
			return this.contentArray[i];
		}
	}
	return;
}

Epg.prototype.updateSortOrder = function(){
	var sortOrder = chm.sortedList;
	for(x=0;x<sortOrder.length;x++){
		if(this.visibleShows == 5)
			this.channelContainers[sortOrder[x]].container.vOffset = 77 * x;
		else
			this.channelContainers[sortOrder[x]].container.vOffset = 51 * x;
	}
	this.updateChannelVisibilty();
}

Epg.prototype.searchSectionHeight = function(){
	var height = 0;
	if(this.searchHeight == 0)
		height = this.searchContentHeight;
	else {
		if(this.searchContentHeight > this.searchHeight)
			height = this.searchHeight;
		else
			height = this.searchContentHeight;
	}
	if(height < 74)
		return 74;
	if(height > screen.availHeight - 50)
		return screen.availHeight - 50
	return height;
}

Epg.prototype.animationHeight = function(){
	if(this.inSearch){
		var height = 0;
		if(this.searchHeight == 0){
			if(this.searchContentHeight >= 74){
				if(this.searchContentHeight > screen.availHeight - 50)
					height = screen.availHeight - 69
				else
					height = this.searchContentHeight - 10;
			} else
				height = this.searchContentHeight - 10;
		} else
			if(this.searchContentHeight > this.searchHeight)
				height = this.searchHeight - 10;
			else
				height = this.searchContentHeight - 10;
		if(height < 74)
			return 64;
		return height;
	}

	var height = this.contentHeight;
	if(height == 0)
		return 60;
	return height - 12;
}

function doresizeEpg(event){
  	epg.doresize(event);
}

function endresizeEpg(event) {
  	epg.endresize();
}


Epg.prototype.beginresize = function(){
	this.resizeorigin = event.y;
	this.resizestart = this.searchSectionHeight();
	document.addEventListener("mousemove",doresizeEpg, false);
	document.addEventListener("mouseup", endresizeEpg, false);
}

Epg.prototype.endresize = function(){
	document.removeEventListener("mousemove",doresizeEpg, false);
	document.removeEventListener("mouseup", endresizeEpg, false);
	savePref(this.searchHeight, "epgSearchScrollPoint");
}

Epg.prototype.resetHeight = function(){
	this.searchHeight = 0;
	savePref("0", "epgSearchScrollPoint");
	this.isSelected = false;
	oldHeight = parseInt(document.getElementById("epgsearch_container").style.height);
	this.resize();
	this.isSelected = true;
	resizeFromHeightReset(oldHeight, document.getElementById("epgsearch_container"));
}

Epg.prototype.doresize = function(event){
	newheight =  event.y - this.resizeorigin;
	this.searchHeight = this.resizestart + newheight;
	if(this.searchHeight < 74)
		this.searchHeight = 74;

	if((this.searchHeight) > this.searchContentHeight)
		this.searchHeight = this.searchContentHeight;

	this.resize();
}

Epg.prototype.setTimeFormat = function(format){
	this.timeFormat = format;
	this.updateDisplay();
}

Epg.prototype.setVisibleShows = function(shows){
	this.visibleShows = shows;
	var sortOrder = chm.sortedList;
	for(x=0;x<sortOrder.length;x++){
		if(this.visibleShows == 5){
			this.channelContainers[sortOrder[x]].container.style.background = "url(images/lists/list_epg_5.png)"
			this.channelContainers[sortOrder[x]].container.style.top = (x * 77) + "px";
			this.channelContainers[sortOrder[x]].container.style.height = "77px";
			this.channelContainers[sortOrder[x]].logo.style.top = "20px";

			var showItem4 = this.channelContainers[sortOrder[x]].showItems[3];
			showItem4.time.style.display = "block";
			showItem4.nameContainer.style.display = "block";
			showItem4.remoteIcons.style.display = "block";

			var showItem5 = this.channelContainers[sortOrder[x]].showItems[4];
			showItem5.time.style.display = "block"
			showItem5.nameContainer.style.display = "block";
			showItem5.remoteIcons.style.display = "block";
		} else {
			this.channelContainers[sortOrder[x]].container.style.background = "url(images/lists/list_epg_3.png)"
			this.channelContainers[sortOrder[x]].container.style.top = (x * 51) + "px";
			this.channelContainers[sortOrder[x]].container.style.height = "51px";
			this.channelContainers[sortOrder[x]].logo.style.top = "7px";
		
			var showItem4 = this.channelContainers[sortOrder[x]].showItems[3];
			showItem4.time.style.display = "none";
			showItem4.nameContainer.style.display = "none";
			showItem4.remoteIcons.style.display = "none";

			var showItem5 = this.channelContainers[sortOrder[x]].showItems[4];
			showItem5.time.style.display = "none";
			showItem5.nameContainer.style.display = "none";
			showItem5.remoteIcons.style.display = "none";
		}
	}
	this.updateChannelVisibilty();
}

Epg.prototype.updateFilterDay = function(){
	this.filterDay = parseInt(loadPref("currentFilterDay"))
	if(this.setupComplete)
		this.updateDisplay();
}

Epg.prototype.updateFilterTime = function(){
	this.filterTime = parseInt(loadPref("currentFilterTime"))
	if(this.setupComplete)
		this.updateDisplay();
}
Epg.prototype.searchPrelim = function(){
	if(this.searchtimer != null)
		clearInterval(this.searchtimer);
	this.searchtimer = null;

	if(document.getElementById("epg-controls-search").value.length == 0)
		this.doSearch();
	else {
		if(document.getElementById("epgsearch_container").style.display != "block"){
			this.doSearch();
		} else {
			var _self = this;
			this.searchtimer = setInterval(function(){ _self.doSearch(); }, 300);
		}
	}
}

Epg.prototype.doSearch = function(){
	sht.forceCloseSheets();

	if(this.searchtimer)
		clearInterval(this.searchtimer)
	this.searchtimer = null;
	
	if(document.getElementById("epg-controls-search").value.length == 0){
		this.inSearch = false;
		this.searchString = null;
		resizeEpgSearch(true);
	} else {
		if(this.inSearch == false)
			this.inSearch = true;
	
		this.searchString = document.getElementById("epg-controls-search").value;
		this.filterWithString(this.searchString)

		if(document.getElementById("epgsearch_container").style.display != "block"){
			this.isSelected = false;
			this.resize();	
			setTimeout("resizeEpgSearch(false)", 100);
			this.isSelected = true;
		} else
			this.resize();	
	}
}

function sortCompleteData(a, b) {
	return a['time'] > b['time'];
}

Epg.prototype.filterWithString = function(searchstring){
	while(document.getElementById("epgsearch_content_inner_container").hasChildNodes())
		document.getElementById("epgsearch_content_inner_container").removeChild(document.getElementById("epgsearch_content_inner_container").firstChild);
	
	this.searchResultDayHeaders.length = 0;
	var currentContainer = null;
	var offset = 0;
	var frameOffset = 0;
	var currentStartDate = null;
	var dateNow = new Date();
	
	var completeData = Array();	
	completeData = completeData.concat(this.contentArray);
	completeData = completeData.sort(sortCompleteData);
	
	var completeDataLength = completeData.length;
	var currentDay = -1;
	var currentContainer = null;
	var currentDayArray = null;
	
    var header = document.createElement("div");
    header.style.position = "absolute";
    header.style.width = "380px";
    header.style.height = "18px";
    header.style.top = "0px";
    offset += 18;
    
    var statusImage = document.createElement("img");
    statusImage.src = "images/remoteicons/remote_keyword.png";
    statusImage.width = 10;
    statusImage.height = 10;
    statusImage.setAttribute("valign", "middle");
    statusImage.style.left = (63) + "px";
    statusImage.style.top = (2) + "px";
    statusImage.style.position = "absolute";
    header.appendChild(statusImage);

    var addKeywordText = document.createElement("div");
    addKeywordText.setAttribute("class", "ellipsis");
    addKeywordText.style.font = "bold 10px Lucida Grande"
    addKeywordText.style.position = "absolute";
    addKeywordText.style.textAlign = "left";
    addKeywordText.style.left = (63 + 12) + "px";
    addKeywordText.style.color = "#ffffff";
    addKeywordText.style.width = (356 - 12 - 63) + "px"
    addKeywordText.setAttribute("onclick", "sht.fillEpgSheetDetails('0', 5, false, false);");
    addKeywordText.innerHTML = "Add a Keyword Rec/Fav for <span class=\"episode-text\">'" + searchstring + "'</span>";
    
    header.appendChild(addKeywordText);
    
    document.getElementById("epgsearch_content_inner_container").appendChild(header);

    var tokenArray = smartSplit( " ", searchstring, false, "\"", true );
    var tokenArrayLength = tokenArray.length;
    
	var totalresults = 0;
	for(x=0;x<completeData.length;x++){
        /**
         * Filter out items on hidden channels
         */
         if(chm.isHidden(completeData[x]['channel_id']))
            continue;

		// Split the search tokens. Keep phrases together and strip the double-quotes.                      
		//   [one "two three" -four] --> (one, two three, -four)                                            
		//   [-title:"blah blah" repeat:yes] --> (-title:blah blah, repeat:yes)                             
		//                                                                                                  
		// title:blah, title:"blah blah", -title:blah, -title:"blah blah"                                   
		// series:blah                                                                                      
		// episode:blah                                                                                     
		// desc:blah                                                                                        
		// genre:blah                                                                                       
		// actor:blah                                                                                       
		// director:blah                                                                                    
		// repeat:[yes|no]                                                                                  
		// year:2009                                                                                        
		// after:2009                                                                                       
		// before:2009       
            
		var found=false;
		var bNegative;
		var strToken;
		var nMatchingTokens;

        if(tokenArrayLength > 0){
			nMatchingTokens = 0;
            for(var i=0;i<tokenArrayLength;i++){
				strToken = tokenArray[i];
				bNegative = (strToken[0] == '-');
				var bMatchFound=false;
				
				// Starts with a -, strip it, we have flagged it as a -ve term
				if(bNegative)
					strToken = strToken.slice(1);

				// If the token is one of our reserved words and there is nothing after the ':'
				// then remove the ':' so it acts like a normal word. ie treat 'genre:' as 'genre'
				// but once you type 'genre:foo' then do a genre search for 'foo'
				if(strToken.toLowerCase() == "title:" 		||
				   strToken.toLowerCase() == "series:" 		||
				   strToken.toLowerCase() == "episode:" 	||
				   strToken.toLowerCase() == "desc:" 		||
				   strToken.toLowerCase() == "genre:" 		||
				   strToken.toLowerCase() == "actor:" 		||
				   strToken.toLowerCase() == "director:" 	||
				   strToken.toLowerCase() == "repeat:" 		||
				   strToken.toLowerCase() == "year:" 		||
				   strToken.toLowerCase() == "after:" 		||
				   strToken.toLowerCase() == "before:") {
					strToken = strToken.slice(0,strToken.length -1);
				}
				
	            /**
	             * Title ( Series + Episode )
	             */
				// title:boys
				if(strToken.toLowerCase().indexOf("title:") == 0) {
					var strTokenEscaped = strToken.slice(6);
	                var matchRegex = new RegExp(strTokenEscaped, "gim");
					var bRegexMatchedSeries = matchRegex.test(completeData[x]['title']);
					var bRegexMatchedEpisode = matchRegex.test(completeData[x]['subtitle']);

					if((bNegative && (!bRegexMatchedSeries && !bRegexMatchedEpisode)) || (!bNegative && (bRegexMatchedSeries||bRegexMatchedEpisode))) {
						bMatchFound = true;
					}
				}

	            /**
	             * Title (Series)
	             */
				// series:boys
				else if(strToken.toLowerCase().indexOf("series:") == 0) {
					var strTokenEscaped = strToken.slice(7);
	                var matchRegex = new RegExp(strTokenEscaped, "gim");
					var bRegexMatched = matchRegex.test(completeData[x]['title']);
					
					if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
						bMatchFound = true;
					}
				}

	            /**
	             * Subtitle (Episode)
	             */
				// episode:Rams
				else if(strToken.toLowerCase().indexOf("episode:") == 0) {
					var strTokenEscaped = strToken.slice(8);
	                var matchRegex = new RegExp(strTokenEscaped, "gim");
					var bRegexMatched = matchRegex.test(completeData[x]['subtitle']);
					
					if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
						bMatchFound = true;
					}
				}

	            /**
	             * Description
	             */
				// desc:ooks
				else if(strToken.toLowerCase().indexOf("desc:") == 0) {
					var strTokenEscaped = strToken.slice(5);
	                var matchRegex = new RegExp(strTokenEscaped, "gim");
					var bRegexMatched = matchRegex.test(completeData[x]['description']);
					
					if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
						bMatchFound = true;
					}
				}

	            /**
	             * Director
	             */
				// director:Willing
				else if(strToken.toLowerCase().indexOf("director:") == 0) {
					var strTokenEscaped = strToken.slice(9);
	                var matchRegex = new RegExp(strTokenEscaped, "gim");
					var bRegexMatched = matchRegex.test(completeData[x]['director']);
					
					if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
						bMatchFound = true;
					}
				}

	            /**
	             * category_name (Genre)
	             */
				// genre:movie
				else if(strToken.toLowerCase().indexOf("genre:") == 0) {
					var strTokenEscaped = strToken.slice(6);
	                var matchRegex = new RegExp(strTokenEscaped, "gim");
					var bRegexMatched = matchRegex.test(completeData[x]['category_name']);
					
					if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
						bMatchFound = true;
					}
				}

	            /**
	             * Actors
	             */
				// actor:willis
				else if(strToken.toLowerCase().indexOf("actor:") == 0) {
					var strTokenEscaped = strToken.slice(6);
	                var matchRegex = new RegExp(strTokenEscaped, "gim");
					var bRegexMatched = matchRegex.test(completeData[x]['actors']);
					
					if((bNegative && !bRegexMatched) || (!bNegative && bRegexMatched)) {
						bMatchFound = true;
					}
				}
				
	            /**
	             * Year (Matches)
	             */
				// year:2009
				else if(strToken.toLowerCase().indexOf("year:") == 0) {
					var strTokenEscaped = strToken.slice(5);
					var nYear = parseInt(completeData[x]['year'], 10);
					var nToken = parseInt(strTokenEscaped, 10);
					
					if((bNegative && (nYear != nToken)) || (!bNegative && (nYear == nToken))) {
						bMatchFound = true;
					}
				}
				
	            /**
	             * Year (After)
	             */
				// after:2009
				else if(strToken.toLowerCase().indexOf("after:") == 0) {
					var strTokenEscaped = strToken.slice(6);
					var nYear = parseInt(completeData[x]['year'], 10);
					var nToken = parseInt(strTokenEscaped, 10);
					
					if((bNegative && (nYear <= nToken)) || (!bNegative && (nYear > nToken))) {
						bMatchFound = true;
					}
				}

	            /**
	             * Year (Before)
	             */
				// before:2009
				else if(strToken.toLowerCase().indexOf("before:") == 0) {
					var strTokenEscaped = strToken.slice(7);
					var nYear = parseInt(completeData[x]['year'], 10);
					var nToken = parseInt(strTokenEscaped, 10);
					
					if((bNegative && (nYear >= nToken)) || (!bNegative && (nYear < nToken))) {
						bMatchFound = true;
					}
				}
				
	            /**
	             * Repeat
	             */
				// repeat:[yes|no|1|0]
				else if(strToken.toLowerCase().indexOf("repeat:") == 0) {
					var strTokenEscaped = strToken.slice(7);
					var bRepeat = parseInt(completeData[x]['flags'],10) & 8
					var bToken = false;
	                var yesRegex = new RegExp("yes|y|1", "gim");
	                var noRegex = new RegExp("no|n|0", "gim");
	                var bYes = yesRegex.test(strToken);
	                var bNo = noRegex.test(strToken);
					
					if((bNo && !bRepeat) || (bYes && bRepeat)) {
						bMatchFound = true;
					}
				}
				
				/**
				 * Token is not restricted could match anything
				 */
				else
				{
					var bTermFound=false;
					var bNegativeFailed=false;

		            /**
		             * Title
		             */
		            if(((!bNegative && !bTermFound) || (bNegative && !bNegativeFailed)) && completeData[x]['title']){
		                var matchRegex = new RegExp(strToken, "gim");
						var bRegexMatched = matchRegex.test(completeData[x]['title']);

						/**
						 * 'Normal' term, may match this field
						 */
						if(!bNegative) {
							if(bRegexMatched)
								bTermFound = true;
						} 
						
						/**
						 * 'Negative' term. If it matched this field then check no more
						 */
						else {
							if(!bNegativeFailed){
								if(bRegexMatched)
									bNegativeFailed = true;
							}
						}
					}

		            /**
		             * Subtitle (Episode)
		             */
		            if(((!bNegative && !bTermFound) || (bNegative && !bNegativeFailed)) && completeData[x]['subtitle']){
	                    var matchRegex = new RegExp(strToken, "gim");
						var bRegexMatched = matchRegex.test(completeData[x]['subtitle']);
						/**
						 * 'Normal' term, may match this field
						 */
						if(!bNegative) {
							if(bRegexMatched)
								bTermFound = true;
						} 
						
						/**
						 * 'Negative' term. If it matched this field then check no more
						 */
						else {
							if(!bNegativeFailed){
								if(bRegexMatched)
									bNegativeFailed = true;
							}
						}
		            }
            
		            /**
		             * Description
		             */
		            if(((!bNegative && !bTermFound) || (bNegative && !bNegativeFailed)) && completeData[x]['description']){
	                    var matchRegex = new RegExp(strToken, "gim");
						var bRegexMatched = matchRegex.test(completeData[x]['description']);
						/**
						 * 'Normal' term, may match this field
						 */
						if(!bNegative) {
							if(bRegexMatched)
								bTermFound = true;
						} 
						
						/**
						 * 'Negative' term. If it matched this field then check no more
						 */
						else {
							if(!bNegativeFailed){
								if(bRegexMatched)
									bNegativeFailed = true;
							}
						}
		            }
            
		            /**
		             * Director
		             */
		            if(((!bNegative && !bTermFound) || (bNegative && !bNegativeFailed)) && completeData[x]['director']){
	                    var matchRegex = new RegExp(strToken, "gim");
						var bRegexMatched = matchRegex.test(completeData[x]['director']);
						/**
						 * 'Normal' term, may match this field
						 */
						if(!bNegative) {
							if(bRegexMatched)
								bTermFound = true;
						} 
						
						/**
						 * 'Negative' term. If it matched this field then check no more
						 */
						else {
							if(!bNegativeFailed){
								if(bRegexMatched)
									bNegativeFailed = true;
							}
						}
		            }
            
		            /**
		             * category_name
		             */
		            if(((!bNegative && !bTermFound) || (bNegative && !bNegativeFailed)) && completeData[x]['category_name']){
	                    var matchRegex = new RegExp(strToken, "gim");
						var bRegexMatched = matchRegex.test(completeData[x]['category_name']);
						/**
						 * 'Normal' term, may match this field
						 */
						if(!bNegative) {
							if(bRegexMatched)
								bTermFound = true;
						} 
						
						/**
						 * 'Negative' term. If it matched this field then check no more
						 */
						else {
							if(!bNegativeFailed){
								if(bRegexMatched)
									bNegativeFailed = true;
							}
						}
		            }
            
		            /**
		             * Actors
		             */
		            if(((!bNegative && !bTermFound) || (bNegative && !bNegativeFailed)) && completeData[x]['actors']){
	                    var matchRegex = new RegExp(strToken, "gim");
						var bRegexMatched = matchRegex.test(completeData[x]['actors']);
						/**
						 * 'Normal' term, may match this field
						 */
						if(!bNegative) {
							if(bRegexMatched)
								bTermFound = true;
						} 
						
						/**
						 * 'Negative' term. If it matched this field then check no more
						 */
						else {
							if(!bNegativeFailed){
								if(bRegexMatched)
									bNegativeFailed = true;
							}
						}
		            }
		
		            /**
		             * Year (Matches)
		             */
		            if(((!bNegative && !bTermFound) || (bNegative && !bNegativeFailed)) && completeData[x]['year']){
						var nYear = parseInt(completeData[x]['year'], 10);
						var nToken = parseInt(strToken, 10);
					
						/**
						 * 'Normal' term, may match this field
						 */
						if(!bNegative) {
							if(nYear == nToken)
								bTermFound = true;
						} 
						
						/**
						 * 'Negative' term. If it matched this field then check no more
						 */
						else {
							if(!bNegativeFailed){
								if(nYear != nToken)
									bNegativeFailed = true;
							}
						}
					}

					if(!bNegative)
						bMatchFound = bTermFound;
					else
						bMatchFound = !bNegativeFailed;
				}
				if(bMatchFound)
					nMatchingTokens++;
			}
        }
        
		if(nMatchingTokens != tokenArrayLength)
			continue;
		
		if(totalresults >= 50)
			break;

        var year	= parseInt(completeData[x]['time'].substring(0,4),   10); 
        var month	= parseInt(completeData[x]['time'].substring(5,7),   10);
        var day     = parseInt(completeData[x]['time'].substring(8,10),  10);
        var hour	= parseInt(completeData[x]['time'].substring(11,13), 10); 
        var minute	= parseInt(completeData[x]['time'].substring(14,16), 10);
        var second	= parseInt(completeData[x]['time'].substring(17,19), 10);
		
        showDate = new Date(year, month-1, day, hour, minute, second);
		
		var showDateString = showDate.getFullYear() + "/" + showDate.getMonth() + "/" + showDate.getDate();

		var showEndDate = new Date();
		showEndDate.setTime(showDate.getTime() + (parseInt(completeData[x]['duration'], 10) * 1000 * 60));

		if(showDate.getTime() < dateNow.getTime() && showEndDate.getTime() <= dateNow.getTime())
			continue;
	
		totalresults++;

		if(showDateString != currentStartDate){			
			currentStartDate = showDateString;
			if(currentContainer != null)
			{
				if(currentContainer != null)
					currentContainer.style.height = (parseInt(currentContainer.style.height) + 4) + "px";
				offset += 6;
			}
			
			var header = document.createElement("div");
			header.style.backgroundImage = "url(images/lists/list_daydivider.png)"
			header.style.position = "absolute";
			header.style.width = "380px";
			header.style.height = "18px";
			header.style.top = offset + "px";
			document.getElementById("epgsearch_content_inner_container").appendChild(header);

			var monthNames = Array('January','February','March','April','May','June','July','August','September','October','November','December');
			var dayNames = Array('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');

			var daytitle = document.createElement("div")
			daytitle.innerHTML = dayNames[showDate.getDay()] + ", " + monthNames[showDate.getMonth()] + " " + showDate.getDate();
			daytitle.style.position = "absolute";
			daytitle.style.font = "bold 10px Lucida Grande"
			daytitle.style.textAlign = "center";
			daytitle.style.left = "10px";
			daytitle.style.top = "3px";
			daytitle.style.width = "360px";
			daytitle.style.color = "#B6BBC3";
			header.appendChild(daytitle);

			
			offset += 18;
			
			frameOffset = 6;
			currentContainer = document.createElement("div");
			currentContainer.style.position = "absolute";
			currentContainer.style.width = "380px";
			currentContainer.style.height = "0px";
			currentContainer.style.top = offset + "px";
			document.getElementById("epgsearch_content_inner_container").appendChild(currentContainer);

			offset += 6;
		}

		completeData[x]['is_favorite']			= isFavoriteYWE(completeData[x]['series_id']);
		completeData[x]['part_of_series']		= isPartOfSeriesYWE(completeData[x]['series_id']);
		completeData[x]['is_scheduled']			= isScheduledYWE(completeData[x]['id']);
		completeData[x]['is_recommeded']		= isRecommendedYWE(completeData[x]['id']);
		completeData[x]['is_keyword']			= isKeywordYWE(completeData[x]['id']);
        completeData[x]['view_or_record']       = keywordViewOrRecordYWE(completeData[x]['id']);

		var header = document.createElement("div")
		header.style.width = "355px";
		header.style.position = "absolute";
		header.style.height = "13px";
		header.style.top = frameOffset + "px";
		currentContainer.style.height = (parseInt(currentContainer.style.height) + 13) + "px";
		currentContainer.appendChild(header);
		offset += 13;
		frameOffset += 13;
		header.setAttribute("onmousedown", "sht.fillEpgSheetDetails('" + completeData[x]["id"] +"', 1, false, false)");

		var time = document.createElement("div");
		time.style.font = "bold 10px Lucida Grande"
		time.style.textAlign = "right";
		time.style.position = "absolute";
		time.style.left = "7px";
		time.style.width = "45px";
		time.style.color = "#B6BBC3";
		header.appendChild(time);
		
        var year	= parseInt(completeData[x]['time'].substring(0,4),   10); 
        var month	= parseInt(completeData[x]['time'].substring(5,7),   10);
        var day     = parseInt(completeData[x]['time'].substring(8,10),  10);
        var hour	= parseInt(completeData[x]['time'].substring(11,13), 10); 
        var minute	= parseInt(completeData[x]['time'].substring(14,16), 10);
        var second	= parseInt(completeData[x]['time'].substring(17,19), 10);
		
        showDate = new Date(year, month-1, day, hour, minute, second);

        if(epg.timeFormat == 24){
            var minutes = showDate.getMinutes();
            if(minutes < 10)
                minutes = "0" + minutes;
                
            var hours = showDate.getHours();
            if(hours < 10)
                hours = "0" + hours;

            time.innerHTML = hours + ':' + minutes;
        } else {
            if(showDate.getHours() >= 12)
                suffix = "pm"
            else
                suffix = "am"
            
            var hours = showDate.getHours();
            if(hours == 0)
                hours = 12;
            else if(hours > 12)
                hours -= 12;

            var minutes = showDate.getMinutes();
            if(minutes < 10)
                minutes = "0" + minutes;
            time.innerHTML = hours + ':' + minutes + suffix;
        }

		var iconSize = 0;
		
		if(completeData[x]['is_scheduled'] == "1"){
			if(completeData[x]['part_of_series'] == "1"){
				var statusImage = document.createElement("img");
				statusImage.src = "images/remoteicons/remote_recseries.png";
				statusImage.width = 14;
				statusImage.height = 12;
				statusImage.setAttribute("valign", "middle");
				header.appendChild(statusImage);
				statusImage.style.left = (63 + iconSize) + "px";
				statusImage.style.top = (2) + "px";
				statusImage.style.position = "absolute";
				iconSize += 18
			} else {
				var statusImage = document.createElement("img");
				statusImage.src = "images/remoteicons/remote_rec.png";
				statusImage.width = 8;
				statusImage.height = 12;
				header.appendChild(statusImage);
				statusImage.style.left = (63 + iconSize) + "px";
				statusImage.style.top = (2) + "px";
				statusImage.style.position = "absolute";
				iconSize += 12
			}
            
			if(completeData[x]['is_keyword'] == "1" && completeData[x]['view_or_record'] == "1"){
				var statusImage = document.createElement("img");
				statusImage.src = "images/remoteicons/remote_smartrec.png";
				statusImage.width = 8;
				statusImage.height = 12;
				header.appendChild(statusImage);
				statusImage.style.left = (63 + iconSize) + "px";
				statusImage.style.top = (2) + "px";
				statusImage.style.position = "absolute";
				iconSize += 12
            }
		} else {
            if(completeData[x]['part_of_series'] == "1"){
                var statusImage = document.createElement("img");
                statusImage.src = "images/remoteicons/remote_recseries_cancel.png";
                statusImage.width = 14;
                statusImage.height = 12;
                statusImage.setAttribute("valign", "middle");
                header.appendChild(statusImage);
                statusImage.style.left = (63 + iconSize) + "px";
                statusImage.style.top = (2) + "px";
                statusImage.style.position = "absolute";
                iconSize += 18
            }
        }
        

		if(completeData[x]['is_favorite'] == "1") {
                var statusImage = document.createElement("img");
                statusImage.src = "images/remoteicons/remote_favourite.png";
                statusImage.width = 14;
                statusImage.height = 12;
                statusImage.style.left = (63 + iconSize) + "px";
                statusImage.style.top = (2) + "px";
                statusImage.style.position = "absolute";
                iconSize += 18;
                header.appendChild(statusImage);
		}

        if(completeData[x]['is_keyword'] == "1" && completeData[x]['view_or_record'] == "0") {
            var statusImage = document.createElement("img");
            statusImage.src = "images/remoteicons/remote_smartfavourite.png";
            statusImage.width = 8;
            statusImage.height = 12;
            statusImage.style.left = (63 + iconSize) + "px";
            statusImage.style.top = (2) + "px";
            statusImage.style.position = "absolute";
            iconSize += 12;
            header.appendChild(statusImage);
        }
        
        if(completeData[x]['is_recommended'] == "1" && completeData[x]['is_favorite'] == "0" && completeData[x]['is_scheduled'] == "0") {
            var statusImage = document.createElement("img");
            statusImage.src = "images/remoteicons/remote_recommended.png";
            statusImage.width = 8;
            statusImage.height = 12;
            statusImage.style.left = (63 + iconSize) + "px";
            statusImage.style.top = (2) + "px";
            statusImage.style.position = "absolute";
            iconSize += 12;
            header.appendChild(statusImage);
        }
        
		if(iconSize > 0)
			iconSize += 1;

		var channel = document.createElement("div");
		channel.setAttribute("class", "ellipsis");
		channel.innerHTML = chm.shortNameForID(completeData[x]["channel_id"]);
		channel.style.font = "bold 10px Lucida Grande, Tahoma Bold"
		channel.style.textAlign = "right";
		channel.style.position = "absolute";
		channel.style.left = "291px";
		channel.style.width = "60px"
		channel.style.color = "#B6BBC3";
		header.appendChild(channel);

		var shownameContainer = document.createElement("div");
		shownameContainer.setAttribute("class", "ellipsis");
		shownameContainer.style.font = "bold 10px Lucida Grande"
		shownameContainer.style.position = "absolute";
		shownameContainer.style.textAlign = "left";
		shownameContainer.style.left = (63 + iconSize) + "px";
		shownameContainer.style.color = "#ffffff";
		shownameContainer.style.width = (286 - iconSize - 63) + "px"
		header.appendChild(shownameContainer);

		var showname = document.createElement("span");
		shownameContainer.appendChild(showname);
		showname.innerHTML = completeData[x]["title"];
		if(completeData[x]['year'] && completeData[x]['year'].length == 4)
			showname.innerHTML += " (" + completeData[x]['year'] + ")";

        /**
         * Check if the program is on NOW and if so colour the text orange like on the website.
         */
        var dateNow = new Date();
        var showDate = new Date();
        var showEndDate = new Date();

        var year	= parseInt(completeData[x]['time'].substring(0,4),   10); 
        var month	= parseInt(completeData[x]['time'].substring(5,7),   10);
        var day     = parseInt(completeData[x]['time'].substring(8,10),  10);
        var hour	= parseInt(completeData[x]['time'].substring(11,13), 10); 
        var minute	= parseInt(completeData[x]['time'].substring(14,16), 10);
        var second	= parseInt(completeData[x]['time'].substring(17,19), 10);
		
        showDate = new Date(year, month-1, day, hour, minute, second);

        var showDateString = showDate.getFullYear() + "/" + (showDate.getMonth()+1) + "/" + showDate.getDate();;

        showEndDate = new Date();
        showEndDate.setTime(showDate.getTime());
        showEndDate.setTime(showEndDate.getTime() + (parseInt(completeData[x]['duration'], 10) * 1000 * 60));

		if(showDate.getTime() <= dateNow.getTime() && showEndDate.getTime() >= dateNow.getTime())
            showname.style.color = "#DB8921"; // On NOW colour
        else
            showname.style.color = "#B6BBC3";
		
		if(completeData[x]["subtitle"] && completeData[x]["subtitle"].length > 0) { 
			var episode = document.createElement("span");
			episode.innerHTML = " '" + completeData[x]["subtitle"] + "'";
			episode.style.color = "#6ED8F8";
			shownameContainer.appendChild(episode);
		}
	}
	offset += 4
	this.searchContentHeight = offset;
}